<template>
  <div class="grid grid-cols-2 gap-2 w-full py-2">
    <template v-if="String($route.name)?.includes('games')">
      <template v-for="provider in providers" :key="provider.ProviderName">
        <MobileGeometryLobbyCard
          :bg-image-path="provider.BackgroundGeometryImage"
          :name="provider.ProviderName"
          :provider-logo-path="provider.providerLogo"
          :star-image-path="provider.starLogo"
          :is-hot="provider.isHotProvider"
          :is-new="provider.isNewProvider"
          @click="() => onClickProviderCard(provider.ProviderName)"
        />
      </template>
    </template>
    <template v-else>
      <template v-for="game in gameForDisplay" :key="game.GameId">
        <MobileGeometryLobbyCard
          :bg-image-path="game.BackgroundGeometryImage"
          :name="game.GameName"
          :provider-logo-path="game.ProviderLogoPath"
          :star-image-path="game.StarImagePath"
          :is-hot="game.IsHotGame"
          :is-new="game.IsNewGame"
          @click="() => onhandleGameEntryOpenWindow(game)"
        />
      </template>
    </template>
  </div>
</template>

<script setup lang="ts">
import SportDisplayModel from "~~/components/sport/sportDisplayModel";
import { IGame } from "~~/models/IGetPlayableGamesResponse";
import { GameBsi, GameProviders } from "~~/models/bsiGameList";
import EnumEntranceLocation from "~~/models/enums/enumEntranceLocation";
import EnumMutation from "~~/models/enums/enumMutation";
import { appNavigationStore } from "~~/store/app-navigation";
import { useGameEntryComponent } from "@/composables/useTheme";

const props = defineProps<{
  gameEntrySelected: GameBsi[];
  providers: GameProviders[];
  handleGameEntryOpenWindow: (
    game: IGame,
    width: number,
    height: number,
    entranceLocation?: EnumEntranceLocation,
    viewAsDesktop?: boolean
  ) => void;
}>();

const gameForDisplay = computed(() =>
  props.gameEntrySelected.map((item) => new SportDisplayModel(item))
);

const route = useRoute();
const router = useRouter();

const onClickProviderCard = (param: string) => {
  if (route.name === "games") {
    router.replace(`/games/${param}`);
    appNavigationStore.commit(
      EnumMutation.updateAppNavigationBackToRoute,
      "/games"
    );
  }
};
const { authenticated } = useGameEntryComponent();
const { toggleLoginRegisterDialog } = commonHelper;
const onhandleGameEntryOpenWindow = (game: IGame) => {
  if (authenticated.value) props.handleGameEntryOpenWindow(game, 550, 850);
  else toggleLoginRegisterDialog();
};
</script>

<style></style>
